'Cellular Automata Class Library
'Copyright (C) 2010, Jrg Meier
'see folder [license] for details.

Option Strict On

<System.CLSCompliant(True)> _
Public MustInherit Class Cell(Of TCell As Cell(Of TCell, TConnection), TConnection As Connection(Of TCell, TConnection))
    Implements ICell


    Sub New(ByVal Parent As Cluster(Of TCell, TConnection))
        Me.mParent = Parent
    End Sub

    Private mParent As Cluster(Of TCell, TConnection)
    Public ReadOnly Property Parent() As Cluster(Of TCell, TConnection)
        Get
            Return mParent
        End Get
    End Property
    Private ReadOnly Property ICell_Parent As ICluster Implements ICell.Parent
        Get
            Return mParent
        End Get
    End Property

    Public Function GetConnections() As TConnection()
        Return Parent.FindConnections(Me)
    End Function
    Private Function ICell_GetConnections() As IEnumerable(Of IConnection) Implements ICell.GetConnections
        Return Me.GetConnections.Cast(Of IConnection)()
    End Function

    Private mIndex As Integer
    Public ReadOnly Property Index() As Integer Implements ICell.Index
        Get
            Return mIndex
        End Get
    End Property
    Friend Sub SetIndex(ByVal value As Integer)
        Me.mIndex = value
    End Sub


End Class
