'Cellular Automata Class Library
'Copyright (C) 2010, Jrg Meier
'see folder [license] for details.

Option Strict On

<System.CLSCompliant(True)> _
Public Class Connection(Of TCell As Cell(Of TCell, TConnection), TConnection As Connection(Of TCell, TConnection))
    Implements IConnection

    Sub New(ByVal Cell1 As TCell, ByVal Cell2 As TCell)
        Me._Cell1 = Cell1
        Me._Cell2 = Cell2
    End Sub


    Private _Index As Integer
    Public ReadOnly Property Index() As Integer Implements IConnection.Index
        Get
            Return _Index
        End Get
    End Property
    Friend Sub SetIndex(ByVal value As Integer)
        Me._Index = value
    End Sub


    Private _Cell1 As TCell
    Public ReadOnly Property Cell1() As TCell
        Get
            Return _Cell1
        End Get
    End Property
    Private ReadOnly Property IConnection_Cell1 As ICell Implements IConnection.Cell1
        Get
            Return Cell1
        End Get
    End Property



    Private _Cell2 As TCell
    Public ReadOnly Property Cell2() As TCell
        Get
            Return _Cell2
        End Get
    End Property
    Private ReadOnly Property IConnection_Cell2 As ICell Implements IConnection.Cell2
        Get
            Return Cell2
        End Get
    End Property

    Function OtherCell(ByVal Cell As TCell) As TCell
        If Cell Is _Cell1 Then
            Return _Cell2
        ElseIf Cell Is _Cell2 Then
            Return _Cell1
        Else
            Throw New ArgumentException("Cell is not a memeber of this connection.")
        End If
    End Function
    Private Function IConnection_OtherCell(ByVal Cell As ICell) As ICell Implements IConnection.OtherCell
        Return OtherCell(CType(Cell, TCell))
    End Function

End Class
