﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On

<System.CLSCompliant(True)> _
Public Interface ICluster

    ReadOnly Property CellCount() As Integer

    Property Cell(ByVal index As Integer) As ICell

    Function FindConnections() As IEnumerable(Of IConnection)

    Function FindConnections(ByVal Cell As ICell) As IEnumerable(Of IConnection)

    ReadOnly Property StepIndex() As Integer

    ''' <summary>
    ''' Gives the total Timespan elapsed for the Cluster
    ''' </summary>
    ReadOnly Property SimulationTime() As Double

    Function DoStep(ByVal e As DoStepArgs) As StepResult

End Interface
