'Cellular Automata Class Library
'Copyright (C) 2010, Jrg Meier
'see folder [license] for details.

Option Strict On

<System.CLSCompliant(True)> _
Friend Class ObservableCollection(Of T)
    Inherits System.Collections.ObjectModel.Collection(Of T)

    Public Event OnBeforeInsertItem(ByVal index As Integer, ByVal item As T)
    Protected Overrides Sub InsertItem(ByVal index As Integer, ByVal item As T)
        RaiseEvent OnBeforeInsertItem(index, item)
        MyBase.InsertItem(index, item)
    End Sub

    Public Event OnBeforeClearItems()
    Protected Overrides Sub ClearItems()
        RaiseEvent OnBeforeClearItems()
        MyBase.ClearItems()
    End Sub

    Public Event OnBeforeRemoveItem(ByVal index As Integer)
    Protected Overrides Sub RemoveItem(ByVal index As Integer)
        RaiseEvent OnBeforeRemoveItem(index)
        MyBase.RemoveItem(index)
    End Sub

    Public Event OnBeforeSetItem(ByVal index As Integer, ByVal item As T)
    Protected Overrides Sub SetItem(ByVal index As Integer, ByVal item As T)
        RaiseEvent OnBeforeSetItem(index, item)
        MyBase.SetItem(index, item)
    End Sub

End Class
