﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On

Imports CellularAutomata

Namespace Specialized

    <System.CLSCompliant(True)> _
    Public MustInherit Class Rectangular1DCell(Of TCell As Rectangular1DCell(Of TCell, TConnection), TConnection As Rectangular1DConnection(Of TCell, TConnection))
        Inherits CellularAutomata.Cell(Of TCell, TConnection)
        Implements IRectangular1DCell

        Sub New(ByVal Parent As Rectangular1DCluster(Of TCell, TConnection))
            MyBase.New(Parent:=Parent)
        End Sub

        Private _IndexX As Integer
        Public Property IndexX() As Integer
            Get
                Return _IndexX
            End Get
            Set(ByVal value As Integer)
                _IndexX = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_IndexX() As Integer Implements IRectangular1DCell.IndexX
            Get
                Return _IndexX
            End Get
        End Property


        Private _LocationX As Double
        Public Property LocationX() As Double
            Get
                Return _LocationX
            End Get
            Set(ByVal value As Double)
                _LocationX = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_LocationX() As Double Implements IRectangular1DCell.LocationX
            Get
                Return _LocationX
            End Get
        End Property

    End Class

End Namespace
