'Cellular Automata Class Library
'Copyright (C) 2010, Jrg Meier
'see folder [license] for details.

Option Strict On
Option Infer On

Imports CellularAutomata

Namespace Specialized

    Partial Class Rectangular1DCluster(Of TCell As Rectangular1DCell(Of TCell, TConnection), TConnection As Rectangular1DConnection(Of TCell, TConnection))

        Public MustInherit Class ClusterFactory
            Private Sub New()
            End Sub

            Shared Sub AddRectangularGridCluster( _
                ByVal cluster As Rectangular1DCluster(Of TCell, TConnection), _
                ByVal CellCount As Integer, _
                ByVal CellFactory As Rectangular1DCellFactory, _
                ByVal ConnectionFactory As ConnectionFactory)

                Dim RectCellFactory = Function(c As Cluster(Of TCell, TConnection), i As Integer) As TCell
                                          Return CellFactory.Invoke(c, i)
                                      End Function

                Dim Cells() As TCell = RectangularClusterFactory.AddRectangularGridCluster( _
                    cluster:=cluster, _
                    CellCount:=CellCount, _
                    CellFactory:=RectCellFactory, _
                    ConnectionFactory:=ConnectionFactory)

                cluster.CellArray = Cells

            End Sub

        End Class

    End Class

End Namespace