﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On
Option Infer On

Imports CellularAutomata

Namespace Specialized

    <System.CLSCompliant(True)> _
    Public MustInherit Class Rectangular1DCluster(Of TCell As Rectangular1DCell(Of TCell, TConnection), TConnection As Rectangular1DConnection(Of TCell, TConnection))
        Inherits specializedCluster(Of TCell, TConnection)
        Implements IRectangular1DCluster

        Private _CellArray() As TCell
        Public Property CellArray() As TCell()
            Get
                Return _CellArray
            End Get
            Friend Set(ByVal value As TCell())
                _CellArray = value
            End Set
        End Property

        Public ReadOnly Property CellCountX As Integer Implements IRectangular1DCluster.CellCountX
            Get
                Return _CellArray.GetLength(0)
            End Get
        End Property


        Private Property IRectangular2DCluster_Cell(ByVal index As Integer) As IRectangular1DCell Implements IRectangular1DCluster.Cell
            Get
                Return MyBase.Cells(index)
            End Get
            Set(ByVal value As IRectangular1DCell)
                MyBase.Cells(index) = CType(value, TCell)
            End Set
        End Property
        Public Property Cell(ByVal index As Integer) As TCell
            Get
                Return MyBase.Cells(index)
            End Get
            Set(ByVal value As TCell)
                MyBase.Cells(index) = value
            End Set
        End Property

    End Class

End Namespace
