﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On

Imports CellularAutomata

Namespace Specialized

    <System.CLSCompliant(True)> _
    Public MustInherit Class Rectangular2DCell(Of TCell As Rectangular2DCell(Of TCell, TConnection), TConnection As Rectangular2DConnection(Of TCell, TConnection))
        Inherits CellularAutomata.Cell(Of TCell, TConnection)
        Implements IRectangular2DCell

        Sub New(ByVal Parent As Rectangular2DCluster(Of TCell, TConnection))
            MyBase.New(Parent:=Parent)
        End Sub

        Private _IndexX As Integer
        Public Property IndexX() As Integer
            Get
                Return _IndexX
            End Get
            Set(ByVal value As Integer)
                _IndexX = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_IndexX() As Integer Implements IRectangular2DCell.IndexX
            Get
                Return _IndexX
            End Get
        End Property

        Private _IndexY As Integer
        Public Property IndexY() As Integer
            Get
                Return _IndexY
            End Get
            Set(ByVal value As Integer)
                _IndexY = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_IndexY() As Integer Implements IRectangular2DCell.IndexY
            Get
                Return _IndexY
            End Get
        End Property


        Private _LocationX As Double
        Public Property LocationX() As Double
            Get
                Return _LocationX
            End Get
            Set(ByVal value As Double)
                _LocationX = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_LocationX() As Double Implements IRectangular2DCell.LocationX
            Get
                Return _LocationX
            End Get
        End Property

        Private _LocationY As Double
        Public Property LocationY() As Double
            Get
                Return _LocationY
            End Get
            Set(ByVal value As Double)
                _LocationY = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_LocationY() As Double Implements IRectangular2DCell.LocationY
            Get
                Return _LocationY
            End Get
        End Property

    End Class

End Namespace
