'Cellular Automata Class Library
'Copyright (C) 2010, Jrg Meier
'see folder [license] for details.

Option Strict On
Option Infer On

Imports CellularAutomata

Namespace Specialized

    Partial Class Rectangular2DCluster(Of TCell As Rectangular2DCell(Of TCell, TConnection), TConnection As Rectangular2DConnection(Of TCell, TConnection))

        Public MustInherit Class ClusterFactory
            Private Sub New()
            End Sub

            Shared Sub AddRectangularGridCluster( _
                ByVal cluster As Rectangular2DCluster(Of TCell, TConnection), _
                ByVal CellCountX As Integer, _
                ByVal CellCountY As Integer, _
                ByVal CellFactory As Rectangular2DCellFactory, _
                ByVal ConnectionFactory As ConnectionFactory, _
                ByVal AddSecondLevelConnections As Boolean)

                Dim RectCellFactory = Function(c As Cluster(Of TCell, TConnection), i As Integer, j As Integer) As TCell
                                          Return CellFactory.Invoke(c, i, j)
                                      End Function

                Dim Cells(,) As TCell = RectangularClusterFactory.AddRectangularGridCluster( _
                    cluster:=cluster, _
                    CellCountX:=CellCountX, _
                    CellCountY:=CellCountY, _
                    CellFactory:=RectCellFactory, _
                    ConnectionFactory:=ConnectionFactory, _
                    AddSecondLevelConnections:=AddSecondLevelConnections)

                cluster.CellArray = Cells

            End Sub

        End Class

    End Class

End Namespace