﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On
Option Infer On

Imports CellularAutomata

Namespace Specialized

    <System.CLSCompliant(True)> _
    Public MustInherit Class Rectangular2DCluster(Of TCell As Rectangular2DCell(Of TCell, TConnection), TConnection As Rectangular2DConnection(Of TCell, TConnection))
        Inherits SpecializedCluster(Of TCell, TConnection)
        Implements IRectangular2DCluster

        Private _CellArray(,) As TCell
        Public Property CellArray() As TCell(,)
            Get
                Return _CellArray
            End Get
            Friend Set(ByVal value As TCell(,))
                _CellArray = value
            End Set
        End Property

        Public ReadOnly Property CellCountX As Integer Implements IRectangular2DCluster.CellCountX
            Get
                Return _CellArray.GetLength(0)
            End Get
        End Property

        Public ReadOnly Property CellCountY As Integer Implements IRectangular2DCluster.CellCountY
            Get
                Return _CellArray.GetLength(1)
            End Get
        End Property

        Private Property IRectangular2DCluster_Cell(ByVal i As Integer, ByVal j As Integer) As IRectangular2DCell Implements IRectangular2DCluster.Cell
            Get
                Return _CellArray(i, j)
            End Get
            Set(ByVal value As IRectangular2DCell)
                _CellArray(i, j) = CType(value, TCell)
            End Set
        End Property
        Public Property Cell(ByVal i As Integer, ByVal j As Integer) As TCell
            Get
                Return _CellArray(i, j)
            End Get
            Set(ByVal value As TCell)
                _CellArray(i, j) = value
            End Set
        End Property

        Private Property IRectangular2DCluster_Cell(ByVal index As Integer) As IRectangular2DCell Implements IRectangular2DCluster.Cell
            Get
                Return MyBase.Cells(index)
            End Get
            Set(ByVal value As IRectangular2DCell)
                MyBase.Cells(index) = CType(value, TCell)
            End Set
        End Property
        Public Property Cell(ByVal index As Integer) As TCell
            Get
                Return MyBase.Cells(index)
            End Get
            Set(ByVal value As TCell)
                MyBase.Cells(index) = value
            End Set
        End Property

    End Class

End Namespace
