﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On

Imports CellularAutomata

Namespace Specialized

    <System.CLSCompliant(True)> _
    Public MustInherit Class Rectangular3DCell(Of TCell As Rectangular3DCell(Of TCell, TConnection), TConnection As Rectangular3DConnection(Of TCell, TConnection))
        Inherits CellularAutomata.Cell(Of TCell, TConnection)
        Implements IRectangular3DCell

        Sub New(ByVal Parent As Rectangular3DCluster(Of TCell, TConnection))
            MyBase.New(Parent:=Parent)
        End Sub

        Private _IndexX As Integer
        Public Property IndexX() As Integer
            Get
                Return _IndexX
            End Get
            Set(ByVal value As Integer)
                _IndexX = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_IndexX() As Integer Implements IRectangular3DCell.IndexX
            Get
                Return _IndexX
            End Get
        End Property

        Private _IndexY As Integer
        Public Property IndexY() As Integer
            Get
                Return _IndexY
            End Get
            Set(ByVal value As Integer)
                _IndexY = value
            End Set
        End Property
        Private ReadOnly Property IRectangular3DCell_IndexY() As Integer Implements IRectangular3DCell.IndexY
            Get
                Return _IndexY
            End Get
        End Property

        Private _IndexZ As Integer
        Public Property IndexZ() As Integer
            Get
                Return _IndexZ
            End Get
            Set(ByVal value As Integer)
                _IndexZ = value
            End Set
        End Property
        Private ReadOnly Property IRectangular3DCell_IndexZ() As Integer Implements IRectangular3DCell.IndexZ
            Get
                Return _IndexZ
            End Get
        End Property

        Private _LocationX As Double
        Public Property LocationX() As Double
            Get
                Return _LocationX
            End Get
            Set(ByVal value As Double)
                _LocationX = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_LocationX() As Double Implements IRectangular3DCell.LocationX
            Get
                Return _LocationX
            End Get
        End Property

        Private _LocationY As Double
        Public Property LocationY() As Double
            Get
                Return _LocationY
            End Get
            Set(ByVal value As Double)
                _LocationY = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_LocationY() As Double Implements IRectangular3DCell.LocationY
            Get
                Return _LocationY
            End Get
        End Property

        Private _LocationZ As Double
        Public Property LocationZ() As Double
            Get
                Return _LocationZ
            End Get
            Set(ByVal value As Double)
                _LocationZ = value
            End Set
        End Property
        Private ReadOnly Property IRectangular2DCell_LocationZ() As Double Implements IRectangular3DCell.LocationZ
            Get
                Return _LocationZ
            End Get
        End Property

    End Class

End Namespace
