'Cellular Automata Class Library
'Copyright (C) 2010, Jrg Meier
'see folder [license] for details.

Option Strict On
Option Infer On

Imports CellularAutomata

Namespace Specialized

    Partial Class Rectangular3DCluster(Of TCell As Rectangular3DCell(Of TCell, TConnection), TConnection As Rectangular3DConnection(Of TCell, TConnection))

        Public MustInherit Class ClusterFactory
            Private Sub New()
            End Sub

            Shared Sub AddRectangularGridCluster( _
                ByVal cluster As Rectangular3DCluster(Of TCell, TConnection), _
                ByVal CellCountX As Integer, _
                ByVal CellCountY As Integer, _
                ByVal CellCountZ As Integer, _
                ByVal CellFactory As Rectangular3DCellFactory, _
                ByVal ConnectionFactory As ConnectionFactory, _
                ByVal AddSecondLevelConnections As Boolean,
                AddTertiaryLevelConnections As Boolean)

                Dim RectCellFactory = Function(c As Cluster(Of TCell, TConnection), i As Integer, j As Integer, k As Integer) As TCell
                                          Return CellFactory.Invoke(c, i, j, k)
                                      End Function

                Dim Cells(,,) As TCell = RectangularClusterFactory.AddRectangularGridCluster( _
                    cluster:=cluster, _
                    CellCountX:=CellCountX, _
                    CellCountY:=CellCountY, _
                    CellCountZ:=CellCountZ, _
                    CellFactory:=RectCellFactory, _
                    ConnectionFactory:=ConnectionFactory, _
                    AddSecondLevelConnections:=AddSecondLevelConnections,
                    AddTertiaryLevelConnections:=AddTertiaryLevelConnections)

                cluster.CellArray = Cells

            End Sub

        End Class

    End Class

End Namespace