﻿'Cellular Automata Class Library
'Copyright (C) 2010, Jörg Meier
'see folder [license] for details.

Option Strict On
Option Infer On

Imports CellularAutomata

Namespace Specialized

    <System.CLSCompliant(True)> _
    Public MustInherit Class Rectangular3DCluster(Of TCell As Rectangular3DCell(Of TCell, TConnection), TConnection As Rectangular3DConnection(Of TCell, TConnection))
        Inherits SpecializedCluster(Of TCell, TConnection)
        Implements IRectangular3DCluster

        Private _CellArray(,,) As TCell
        Public Property CellArray() As TCell(,,)
            Get
                Return _CellArray
            End Get
            Friend Set(ByVal value As TCell(,,))
                _CellArray = value
            End Set
        End Property

        Public ReadOnly Property CellCountX As Integer Implements IRectangular3DCluster.CellCountX
            Get
                Return _CellArray.GetLength(0)
            End Get
        End Property

        Public ReadOnly Property CellCountY As Integer Implements IRectangular3DCluster.CellCountY
            Get
                Return _CellArray.GetLength(1)
            End Get
        End Property

        Public ReadOnly Property CellCountZ As Integer Implements IRectangular3DCluster.CellCountZ
            Get
                Return _CellArray.GetLength(2)
            End Get
        End Property

        Private Property IRectangular2DCluster_Cell(ByVal i As Integer, ByVal j As Integer, ByVal k As Integer) As IRectangular3DCell Implements IRectangular3DCluster.Cell
            Get
                Return _CellArray(i, j, k)
            End Get
            Set(ByVal value As IRectangular3DCell)
                _CellArray(i, j, k) = CType(value, TCell)
            End Set
        End Property
        Public Property Cell(ByVal i As Integer, ByVal j As Integer, ByVal k As Integer) As TCell
            Get
                Return _CellArray(i, j, k)
            End Get
            Set(ByVal value As TCell)
                _CellArray(i, j, k) = value
            End Set
        End Property

        Private Property IRectangular2DCluster_Cell(ByVal index As Integer) As IRectangular3DCell Implements IRectangular3DCluster.Cell
            Get
                Return MyBase.Cells(index)
            End Get
            Set(ByVal value As IRectangular3DCell)
                MyBase.Cells(index) = CType(value, TCell)
            End Set
        End Property
        Public Property Cell(ByVal index As Integer) As TCell
            Get
                Return MyBase.Cells(index)
            End Get
            Set(ByVal value As TCell)
                MyBase.Cells(index) = value
            End Set
        End Property

    End Class

End Namespace
